﻿declare module 'cb-express-async' {
  import express = require('express');

  namespace create {
    export type AsyncHandlerFn = (path: string | RegExp | (string|RegExp)[], asyncHandler: (req?: express.Request,
      res?: express.Response,
      next?: express.NextFunction) => Promise<any>|IterableIterator<any>) => any;

    export interface IExpressAsync {
      'all': AsyncHandlerFn;
      'checkout': AsyncHandlerFn;
      'copy': AsyncHandlerFn;
      'delete': AsyncHandlerFn;
      'get': AsyncHandlerFn;
      'head': AsyncHandlerFn;
      'lock': AsyncHandlerFn;
      'merge': AsyncHandlerFn;
      'mkactivity': AsyncHandlerFn;
      'mkcol': AsyncHandlerFn;
      'move': AsyncHandlerFn;
      'm-search': AsyncHandlerFn;
      'notify': AsyncHandlerFn;
      'options': AsyncHandlerFn;
      'patch': AsyncHandlerFn;
      'post': AsyncHandlerFn;
      'purge': AsyncHandlerFn;
      'put': AsyncHandlerFn;
      'report': AsyncHandlerFn;
      'search': AsyncHandlerFn;
      'subscribe': AsyncHandlerFn;
      'trace': AsyncHandlerFn;
      'unlock': AsyncHandlerFn;
      'unsubscribe': AsyncHandlerFn;
      'use': AsyncHandlerFn;
    }
  }

  function create(express: express.Application | express.Router): create.IExpressAsync;

  export = create;
}